我遇到了在bash脚本中终止进程执行的问题。
基本上我的脚本执行以下操作:
CTRL+C
停止我的问题是,当我点击CTRL+C
时,整个脚本终止,而不仅仅是"内部"程序
我已经看到一些脚本执行此操作,这就是为什么我认为这是可能的。
提前致谢!
答案 0 :(得分:1)
您可以使用trap
设置信号处理程序:
trap 'myFunction arg1 arg2 ...' SIGINT;
我建议你的脚本整体可以中止,你可以使用一个简单的布尔值来完成:
#!/bin/bash
# define signal handler and its variable
allowAbort=true;
myInterruptHandler()
{
if $allowAbort; then
exit 1;
fi;
}
# register signal handler
trap myInterruptHandler SIGINT;
# some commands...
# before calling the inner program,
# disable the abortability of the script
allowAbort=false;
# now call your program
./my-inner-program
# and now make the script abortable again
allowAbort=true;
# some more commands...
为了减少弄乱allowAbort
的可能性,或者只是为了让它更清洁,你可以定义一个包装函数来为你完成这项任务:
#!/bin/bash
# define signal handler and its variable
allowAbort=true;
myInterruptHandler()
{
if $allowAbort; then
exit 1;
fi;
}
# register signal handler
trap myInterruptHandler SIGINT;
# wrapper
wrapInterruptable()
{
# disable the abortability of the script
allowAbort=false;
# run the passed arguments 1:1
"$@";
# save the returned value
local ret=$?;
# make the script abortable again
allowAbort=true;
# and return
return "$ret";
}
# call your program
wrapInterruptable ./my-inner-program